#pragma once

//
//	Copyright (C) 1998 Kostya Vasilyev, kostik@pobox.com
//
//	This program is free software; you can redistribute it and/or
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#include "KvBonesDefs.h"
#include "KvBonesData.h"

// ---------------------------------------------------------------------------

class KvBones;
struct Vtx;

// ---------------------------------------------------------------------------
//
// UndoVertexEdit
//

class UndoVertexEdit : public RestoreObj
{
public:
	virtual ~UndoVertexEdit();

	virtual void Restore(int isUndo);
	virtual void Redo();
	virtual int Size();

	static void Begin(KvBones* bones, int nVertex);
	static void End();

private:
	UndoVertexEdit(KvBones* bones, int nVertex);

	KvBones*	m_bones;
	int			m_vertex;
	VtxState	m_save;

	static int	g_count;
};

// ---------------------------------------------------------------------------
//
// UndoBoneEdit
//

class UndoBoneEdit : public RestoreObj
{
public:
	virtual ~UndoBoneEdit();

	virtual void Restore(int isUndo);
	virtual void Redo();
	virtual int Size();

	static UndoBoneEdit* Create(KvBones* bones);

private:
	UndoBoneEdit(KvBones* bones);

	KvBones*				m_bones;

	int						m_count;
	BoneState*				m_state;
	KvLocalModDataState		m_mod;
};

#if 0

// ---------------------------------------------------------------------------
//
// UndoBonePosPaste
//

class UndoBonePosPaste : public RestoreObj
{
public:
	UndoBonePosPaste(BoneInfo* pBoneList, int nCount, TimeValue t);
	virtual ~UndoBoneEdit();

	virtual void Restore(int isUndo);
	virtual void Redo();
	virtual int Size();
};

#endif

