//
//	Copyright (C) 1998 Kostya Vasilyev, kostik@pobox.com
//
//	This program is free software; you can redistribute it and/or
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

/**********************************************************************
 *<
	FILE: kvBones.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 1997, All Rights Reserved.
 **********************************************************************/

#include <stdio.h>

#include "kvBones.h"
#include "KvBonesDialogs.h"
#include "KvBonesData.h"
#include "KvBonesUndo.h"

HINSTANCE hInstance;
int controlsInit = FALSE;

// This function is called by Windows when the DLL is loaded.  This 
// function may also be called many times during time critical operations
// like rendering.  Therefore developers need to be careful what they
// do inside this function.  In the code below, note how after the DLL is
// loaded the first time only a few statements are executed.

BOOL WINAPI DllMain(HINSTANCE hinstDLL,ULONG fdwReason,LPVOID lpvReserved)
{
	hInstance = hinstDLL;				// Hang on to this DLL's instance handle.

	if (!controlsInit) {
		controlsInit = TRUE;
		InitCustomControls(hInstance);	// Initialize MAX's custom controls
		InitCommonControls();			// Initialize Win95 controls
	}
			
	return (TRUE);
}

// This function returns a string that describes the DLL and where the user
// could purchase the DLL if they don't have it.

__declspec( dllexport ) const TCHAR* LibDescription()
{
	return GetString(IDS_LIBDESCRIPTION);
}

// This function returns the number of plug-in classes this DLL

__declspec( dllexport ) int LibNumberClasses()
{
	return 2;
}

// This function returns the number of plug-in classes this DLL

static KvBonesClassDesc			KvBonesDesc;
static KvBonesObjClassDesc		KvBonesObjDesc;

__declspec( dllexport ) ClassDesc* LibClassDesc(int i)
{
	switch(i) {
		case 0: return &KvBonesObjDesc;
		case 1: return &KvBonesDesc;
		default: return 0;
	}
}

// This function returns a pre-defined constant indicating the version of 
// the system under which it was compiled.  It is used to allow the system
// to catch obsolete DLLs.

__declspec( dllexport ) ULONG LibVersion()
{
	return VERSION_3DSMAX;
}

TCHAR *GetString(int id)
{
	static TCHAR buf[256];

	if (hInstance)
		return LoadString(hInstance, id, buf, sizeof(buf)) ? buf : NULL;
	return NULL;
}

TriObject* GetTriObjectFromObject(Object *obj, TimeValue t, bool &deleteIt)
{
	deleteIt = FALSE;
	if (obj->CanConvertToType(Class_ID(TRIOBJ_CLASS_ID, 0))) { 
		TriObject *tri = (TriObject *) obj->ConvertToType(t, Class_ID(TRIOBJ_CLASS_ID, 0));
		// Note that the TriObject should only be deleted
		// if the pointer to it is not equal to the object
		// pointer that called ConvertToType()
		if (obj != tri) deleteIt = TRUE;
		return tri;
	} else {
		return NULL;
	}
}

void KvBonesObjClassDesc::ResetClassParams (BOOL fileReset)
{
}

void KvBonesClassDesc::ResetClassParams (BOOL fileReset) 
{
}

//TODO: Add Parameter block indices for various parameters
#define PB_SPINNER			0

//TODO: Add ParamUIDesc's for the various parameters
static ParamUIDesc descParam[] = {
	// Spinner
	ParamUIDesc(
		PB_SPINNER,
		EDITTYPE_FLOAT,
		IDC_EDIT, IDC_SPIN,
		-1000.0f,1000.0f,
		0.1f),	
	}; 	

//TODO: Parameter descriptor length
#define PARAMDESC_LENGTH 1

//TODO: Add ParamBlockDescID's for the various parameters
static ParamBlockDescID descVer1[] = {
	{ TYPE_FLOAT, NULL, TRUE, 0 },	//spinner
	};

#define CURRENT_DESCRIPTOR descVer1

#define PBLOCK_LENGTH	1

#define CURRENT_VERSION	1


// ---------------------------------------------------------------------------
//
// class KvBonesObject
//

static ParamBlockDescID descObj[] = {
	{ TYPE_FLOAT, NULL, TRUE, 0 },
	};

KvBonesObject::KvBonesObject()
{
	pblock = CreateParameterBlock(
				descObj, 
				sizeof(descObj) / sizeof(descObj[0]), 
				CURRENT_VERSION);
	AxAssert(pblock);
	MakeRefByID(FOREVER, 0, pblock);
}

KvBonesObject::~KvBonesObject()
{
}

KvBonesObjectCreateCallback mouseCallback;

CreateMouseCallBack* KvBonesObject::GetCreateMouseCallBack()
{
	mouseCallback.SetObj(this);
	return &mouseCallback; 
}

Modifier *KvBonesObject::CreateWSMMod(INode *node)
{
	return new KvBones(this, node);
}

void KvBonesObject::BuildMesh(TimeValue t)
{
	int nverts, nfaces;
	ivalid = FOREVER;

#if 0
	pblock->GetValue(PB_AMPLITUDE,t,a,ivalid);
	pblock->GetValue(PB_AMPLITUDE2,t,a2,ivalid);
	pblock->GetValue(PB_WAVELEN,t,w,ivalid);
	pblock->GetValue(PB_PHASE,t,s,ivalid);
	pblock->GetValue(PB_DECAY,t,d,ivalid);
	pblock->GetValue(PB_SEGMENTS,t,numCircleSegs,ivalid);
	pblock->GetValue(PB_CIRCLES,t,numCircles,ivalid);
	pblock->GetValue(PB_DIVISIONS,t,divs,ivalid);
	LimitValue(d,0.0f,float(1.0E30));
#endif

	nverts = 4;
	nfaces = 2;
	mesh.setNumVerts(nverts);
	mesh.setNumFaces(nfaces);

	float size = 10.0f;

	mesh.setVert( 0, Point3(0.0f, 0.0f, 0.0f) );
	mesh.setVert( 1, Point3(0.0f, size, 0.0f) );
	mesh.setVert( 2, Point3(size, size, 0.0f) );
	mesh.setVert( 3, Point3(size, 0.0f, 0.0f) );

	mesh.faces[0].setVerts( 0, 3, 1);
	mesh.faces[0].setSmGroup(0);
	mesh.faces[0].setEdgeVisFlags(1,1,1);

	mesh.faces[1].setVerts( 1, 3, 2);
	mesh.faces[1].setSmGroup(0);
	mesh.faces[1].setEdgeVisFlags(1,1,1);


#if 0

	int i;

	mesh.setNumVertCol(nverts);
	mesh.setNumVCFaces(nfaces);

	mesh.vertCol[0] = Point3(1.0f, 0.0f, 0.0f);
	mesh.vertCol[1] = Point3(0.0f, 1.0f, 0.0f);
	mesh.vertCol[2] = Point3(0.0f, 0.0f, 1.0f);
	mesh.vertCol[3] = Point3(1.0f, 1.0f, 1.0f);

	for (i=0; i<mesh.numFaces; i++) {
		mesh.vcFace[i].t[0] = mesh.faces[i].v[0];
		mesh.vcFace[i].t[1] = mesh.faces[i].v[1];
		mesh.vcFace[i].t[2] = mesh.faces[i].v[2];
	}

#endif

	mesh.InvalidateGeomCache();
	mesh.InvalidateTopologyCache();
}

void KvBonesObject::BeginEditParams( IObjParam  *ip, ULONG flags,Animatable *prev )
{
}

void KvBonesObject::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
}

// ---------------------------------------------------------------------------
//
// class KvBonesObjectCreateCallback
//

int KvBonesObjectCreateCallback::proc( ViewExp *vpt,int msg, int point, int flags, IPoint2 m, Matrix3& mat)
{
	if (msg == MOUSE_POINT || msg == MOUSE_MOVE) {
		switch(point) {
			case 0:
				sp0    = m;
				p0     = vpt->GetPointOnCP(m);
				mat.SetTrans(p0);
				break;

			case 1:
				sp1    = m;
				p1     = vpt->GetPointOnCP(m);
				mat.SetTrans(p1);
				if (msg == MOUSE_POINT) 
					return CREATE_STOP;

				ob->NotifyDependents(FOREVER, GEOM_CHANNEL, REFMSG_CHANGE);
				break;
		}
	} else if (msg == MOUSE_ABORT)
		return CREATE_ABORT;

	return CREATE_CONTINUE;
}

//--- KvBonesDeformer -----------------------------------------------

KvBonesDeformer::KvBonesDeformer() : m_Value(0.0f), m_pBones(NULL)
{ 
}

void	KvBonesDeformer::Init(TimeValue t, KvBones* pBones, float value, KvLocalModData* modData)
{
	m_pBones = pBones;
	m_pModData = modData;

	BoneInfo*	bb = m_pBones->m_pBoneList;
	BoneInfo*	be = m_pBones->m_pBoneList + m_pBones->m_nBoneCount;

	while (bb != be) {
		if (bb->bone) {
			Point3 p, q;
			bb->GetPQ(t, p, q);

			Point3 qmp		= q - p;
			float qmplen	= Length(qmp);

			Point3 scale(1.0f, 1.0f, qmplen / bb->qmplen);

#ifdef ENABLE_TWIST

			// twist test

			Matrix3 matBase;
			bb->GetBase(t, matBase);

			bb->matp = Inverse(bb->matBase);
			bb->matp *= matBase;

#else

			bb->matp.IdentityMatrix();

			bb->matp.Translate(-bb->p);

			float dot = DotProd(qmp, bb->qmp) / (qmplen * bb->qmplen);
			if (dot < 1.0f - 1.0e-5f) {
				Point3 axis = Normalize(CrossProd(bb->qmp, qmp));
				bb->matp *= RotAngleAxisMatrix(axis, (float) acos(dot));
			}

			bb->matp.Scale(scale);

			bb->matp.Translate(p);
#endif
		}

		++ bb;
	}
}

Point3	KvBonesDeformer::Map(int i, Point3 p)
{
	if (i >= 0 && i < m_pModData->m_nCount) {
		Vtx& vtx = m_pModData->m_pList[i];

		if (vtx.bone1 != NULL) 	{
			AxAssert(vtx.bone0 != NULL);

			Point3 p0 = vtx.bone0->matp * p;
			Point3 p1 = vtx.bone1->matp * p;

#ifdef _DEBUG
			static int force = 0;

			switch (force) {
				case 1:
					p = p0;
					break;

				case 2:
					p = p1;
					break;

				case 3:
					p = vtx.wght0 * p0;
					break;

				case 4:
					p = vtx.wght1 * p1;
					break;

				default:
					p = vtx.wght0 * p0 + vtx.wght1 * p1;
			}
#else
			p = vtx.wght0 * p0 + vtx.wght1 * p1;
#endif
		} else if (vtx.bone0 != NULL) {
			p = vtx.bone0->matp * p;
		}
	}

	return p;
}

// ---------------------------------------------------------------------------
//
// class KvBonesMouseCallback
//

KvBonesMouseCallback KvBonesMouseCallback::instance;

int KvBonesMouseCallback::proc( 
		HWND hwnd, 
		int msg, 
		int point, 
		int flags, 
		IPoint2 m )
{
#if 0

	char buf[200];
	#define CASE_MSG(m)	case m: sprintf(buf, "%20s %d\n", #m, point); OutputDebugString(buf); break

	switch (msg) {
		CASE_MSG(MOUSE_IDLE);
		CASE_MSG(MOUSE_POINT);
		CASE_MSG(MOUSE_MOVE);
		CASE_MSG(MOUSE_DBLCLICK);
		CASE_MSG(MOUSE_INIT);
		CASE_MSG(MOUSE_UNINIT);
//		CASE_MSG(MOUSE_FREEMOVE);
		CASE_MSG(MOUSE_KEYBOARD);
		CASE_MSG(MOUSE_PROPCLICK);
		CASE_MSG(MOUSE_SNAPCLICK);
	}

#endif

	if (msg == MOUSE_INIT) {
		// load cursors
		hcurSelect			= LoadCursor(NULL, IDC_SIZEALL);
		hcurArrow			= LoadCursor(NULL, IDC_ARROW);
		hcurPickWeight		= LoadCursor(hInstance, MAKEINTRESOURCE(IDC_PICKWEIGHT));
		hcurAddVertex		= LoadCursor(hInstance, MAKEINTRESOURCE(IDC_ADDVERTEX));
		hcurRemoveVertex	= LoadCursor(hInstance, MAKEINTRESOURCE(IDC_REMOVEVERTEX));
		hcurSetWeight		= LoadCursor(hInstance, MAKEINTRESOURCE(IDC_SETWEIGHT));
	} else if (msg == MOUSE_UNINIT) {
		// free cursors
		DestroyCursor(hcurSelect);			hcurSelect = NULL;
		DestroyCursor(hcurArrow);			hcurArrow = NULL;
		DestroyCursor(hcurPickWeight);		hcurPickWeight = NULL;
		DestroyCursor(hcurAddVertex);		hcurAddVertex = NULL;
		DestroyCursor(hcurRemoveVertex);	hcurRemoveVertex = NULL;
		DestroyCursor(hcurSetWeight);		hcurSetWeight = NULL;
	} else if (bones->m_nSelectBone != -1) {

		HCURSOR hCursor = hcurArrow;

		if (msg == MOUSE_FREEMOVE) {
			// ------ process mouse move before the first point
			HitRegion hr;
			MakeHitRegion(hr, POINT_RGN, true, 4, &m);

			SubObjHitList hitList;
			int res = HitTest(hwnd, hr, hitList);

			if (res != 0) {
				if ((flags & MOUSE_CTRL) != 0)
					hCursor = hcurAddVertex;
				else if ((flags & MOUSE_ALT) != 0)
					hCursor = hcurRemoveVertex;
				else if ((flags & MOUSE_SHIFT) != 0)
					hCursor = hcurSetWeight;
				else
					hCursor = hcurPickWeight;
			}

		} else if (msg == MOUSE_POINT && point == 0) {
			// ----- process beginning of selection
			mpt[0] = m;
			selectRect = false;
		} else if (msg == MOUSE_MOVE) {
			// ----- process mouse move between points
			if (selectRect)
				InvertSelectRect(hwnd);

			selectRect = true;
			mpt[1] = m;
			InvertSelectRect(hwnd);
		} else if (msg == MOUSE_POINT && point == 1) {
			// ----- process end of selection

			HitRegion hr;

			if (selectRect) {
				InvertSelectRect(hwnd);
				mpt[1] = m;
				MakeHitRegion(hr, RECT_RGN, true, 4, mpt);
			} else {
				MakeHitRegion(hr, POINT_RGN, true, 4, &m);
			}

			SubObjHitList hitList;
			int res = HitTest(hwnd, hr, hitList);

			if (res) {

				hCursor = hcurSelect;

				BoneInfo* bone = bones->m_pBoneList + bones->m_nSelectBone;
				AxAssert(bone != NULL && bone->bone);

				KvLocalModData* mod = bones->m_pModData;		

				TimeValue t = KvBones::ip->GetTime();
				
				MeshSubHitRec * hit = hitList.First(), *lastHit = hit;
				AxAssert(hit != NULL);

				// UI change variables
				bool bRedraw = false;
				bool bind_chg = false;
				int bind_vtx, bind_bone;
				float bind_wght;

				if ((flags & MOUSE_CTRL) != 0) {
					// add the bone to the vertex

					for (; hit != NULL; lastHit = hit, hit = hit->Next()) {
						Vtx& vtx= mod->m_pList[hit->index];

						if (vtx.bone0 != bone && vtx.bone1 != bone) {

							UndoVertexEdit::Begin(bones, hit->index);
							bRedraw = true;

							if (vtx.bone0 == NULL) {
								vtx.bone0 = bone;
								vtx.wght0 = 1.0f;

								bind_chg = true;
								bind_vtx = hit->index;
								bind_bone = 0;
								bind_wght = vtx.wght0;
							} else {
								vtx.bone1 = bone;
								vtx.wght1 = KvBonesDlgProc::instance.GetWeight();
								vtx.wght0 = 1.0f - vtx.wght1;

								bind_chg = true;
								bind_vtx = hit->index;
								bind_bone = 1;
								bind_wght = vtx.wght1;
							}
						}
					}

					UndoVertexEdit::End();

				} else if ((flags & MOUSE_ALT) != 0) {
					// remove the bone from the vertex

					for (; hit != NULL; lastHit = hit, hit = hit->Next()) {
						Vtx& vtx= mod->m_pList[hit->index];

						if (vtx.bone0 == bone || vtx.bone1 == bone) {

							UndoVertexEdit::Begin(bones, hit->index);
							bRedraw = true;

							if (vtx.bone1 == bone) {
								// unbind bone1
								vtx.bone1 = NULL;
								vtx.wght1 = 0.0f;

								vtx.wght0 = 1.0f;
							} else if (vtx.bone0 == bone) {
								// move bone1 to bone0
								vtx.bone0 = vtx.bone1;
								vtx.wght0 = 1.0f;

								// and unbind bone1
								vtx.bone1 = NULL;
								vtx.wght1 = 0.0f;
							}

							bind_chg = true;
							bind_vtx = -1;
						}
					}

					UndoVertexEdit::End();

				} else if((flags & MOUSE_SHIFT) != 0) {
					// set the bone's weight

					for (; hit != NULL; lastHit = hit, hit = hit->Next()) {
						Vtx& vtx = mod->m_pList[hit->index];

						if (vtx.bone0 == bone || vtx.bone1 == bone) {

							UndoVertexEdit::Begin(bones, hit->index);
							bRedraw = true;

							if (vtx.bone0 == bone) {
								KvBonesDlgProc::instance.SetVertexWeight(vtx, 0);

								bind_chg = true;
								bind_vtx = hit->index;
								bind_bone = 0;
								bind_wght = vtx.wght0;
							} else if (vtx.bone1 == bone) {
								KvBonesDlgProc::instance.SetVertexWeight(vtx, 1);

								bind_chg = true;
								bind_vtx = hit->index;
								bind_bone = 1;
								bind_wght = vtx.wght1;
							}
						}
					}

					UndoVertexEdit::End();

				} else {
					// pick up vertex weight
					Vtx& vtx= mod->m_pList[hit->index];

					if (vtx.bone0 == bone) {
						bind_chg = true;
						bind_vtx = hit->index;
						bind_bone = 0;
						bind_wght = vtx.wght0;
					} else if (vtx.bone1 == bone) {
						bind_chg = true;
						bind_vtx = hit->index;
						bind_bone = 1;
						bind_wght = vtx.wght1;
					}
				}

				// process UI changes

				if (bRedraw) {
					// reflect the change in 3D window
					bones->ForceRedraw();
					KvBones::ip->RedrawViews(t);
				}

				if (bind_chg) {
					// vertex binding
					KvBonesDlgProc::instance.BindToVertex(bind_vtx, bind_bone, bind_wght);
				}

				KvBonesDlgProc::instance.ShowVertexInfo(lastHit->index);
			}
		}

		SetCursor(hCursor);
	}

	return TRUE;
}

int	KvBonesMouseCallback::HitTest(HWND hwnd, HitRegion& hr, SubObjHitList& hitList)
{
	Mesh& mesh = bones->m_meshCopy;

	ViewExp * vpt = KvBones::ip->GetViewport(hwnd);
	GraphicsWindow *gw = vpt->getGW();

	gw->setHitRegion(&hr);
	gw->clearHitCode();

	int res = mesh.SubObjectHitTest(gw, gw->getMaterial(), &hr,
		SUBHIT_VERTS, hitList);

	KvBones::ip->ReleaseViewport(vpt);		

	return res;
}

void KvBonesMouseCallback::InvertSelectRect(HWND hwnd)
{
	HDC hdc = GetDC(hwnd);

	RECT rc = { mpt[0].x, mpt[0].y, mpt[1].x, mpt[1].y };
	DrawFocusRect(hdc, &rc);

	ReleaseDC(hwnd, hdc);
}

// ---------------------------------------------------------------------------
//
// class KvBonesCommandMode
//

KvBonesCommandMode	KvBonesCommandMode::instance;

int KvBonesCommandMode::Class()
{
	return CREATE_COMMAND;
}

int KvBonesCommandMode::ID()
{
	return CID_BONESCOMMAND;
}

MouseCallBack *KvBonesCommandMode::MouseProc(int *numPoints)
{
	*numPoints = 2;
	return proc;
}

ChangeForegroundCallback *KvBonesCommandMode::ChangeFGProc()
{
	return CHANGE_FG_SELECTED;
}

BOOL KvBonesCommandMode::ChangeFG( CommandMode *oldMode )
{
	return oldMode->ChangeFGProc() != CHANGE_FG_SELECTED;
}

void KvBonesCommandMode::EnterMode()
{
}

void KvBonesCommandMode::ExitMode()
{
}

void KvBonesCommandMode::Install(IObjParam* ip, KvBones* bones, KvBonesMouseCallback& mc)
{
	proc = &KvBonesMouseCallback::instance;
	mc.bones = bones;
	ip->PushCommandMode(this);
}

void KvBonesCommandMode::Remove(IObjParam* ip)
{
	ip->DeleteMode(this);
}

// ---------------------------------------------------------------------------
//
// class KvBonesDlgProc
//

KvBonesDlgProc KvBonesDlgProc::instance;

void KvBonesDlgProc::DeleteThis()
{
	m_hWnd = NULL;
}

float KvBonesDlgProc::GetWeight()
{
	ISpinnerControl* iS = GetISpinner(m_hwndWeightSpin);
	float f = iS->GetFVal();
	ReleaseISpinner(iS);
	return f;
}

void KvBonesDlgProc::BindToVertex(int nVertex, int nBone, float wght)
{
	if (m_hWnd != NULL) {
		m_nBoundVertex = nVertex;
		m_nBoundBone = nBone;

		ISpinnerControl*	iS = GetISpinner(m_hwndWeightSpin);
		ICustEdit*			iE = GetICustEdit(m_hwndWeightEdit);

		if (m_nBoundVertex == -1) {
			SetWindowText(m_hwndWeightText, __T("Weight [unbound]:"));
		} else {
			TCHAR buf[200];
			_snprintf(buf, sizeof(buf) / sizeof(TCHAR), __T("Weight [v %d, b %d]:"),
				m_nBoundVertex, m_nBoundBone);
			SetWindowText(m_hwndWeightText, buf);

			iS->SetValue(wght, false);
			iE->SetText(wght);
		}

		ReleaseISpinner(iS);
		ReleaseICustEdit(iE);
	}
}

void KvBonesDlgProc::ShowVertexInfo(int n)
{
	if (m_hWnd != NULL) {
		if (n == -1) {
			SetWindowText(m_hwndInfoV, __T("Vertex info [none]"));
			SetWindowText(m_hwndInfo0, NULL);
			SetWindowText(m_hwndInfo1, NULL);
		} else {
			Vtx& vtx = KvBones::g_pCurr->m_pModData->m_pList[n];

			char buf[200];

			_snprintf(buf, sizeof(buf) / sizeof(TCHAR), __T("Vertex info [%d]"), n);
			SetWindowText(m_hwndInfoV, buf);

			if (vtx.bone0 != NULL) {
				_snprintf(buf, sizeof(buf) / sizeof(TCHAR), __T("%s: %f"), vtx.bone0->GetName(), vtx.wght0);
				SetWindowText(m_hwndInfo0, buf);
			} else {
				SetWindowText(m_hwndInfo0, __T("No bone 0"));
			}

			if (vtx.bone1 != NULL) {
				_snprintf(buf, sizeof(buf) / sizeof(TCHAR), __T("%s: %f"), vtx.bone1->GetName(), vtx.wght1);
				SetWindowText(m_hwndInfo1, buf);
			} else {
				SetWindowText(m_hwndInfo1, __T("No bone 1"));
			}
		}
	}
}

void KvBonesDlgProc::OnInitDialog(HWND hWnd)
{
	m_hWnd = hWnd;

	char buf[200];
	sprintf(buf, "%d bones", KvBones::g_pCurr->m_nBoneCount);
	SetDlgItemText(hWnd, IDC_MSG_BONES, buf);

	// init custom controls

	m_hwndWeightSpin = GetDlgItem(hWnd, IDC_WEIGHT_SPIN);
	m_hwndWeightEdit = GetDlgItem(hWnd, IDC_WEIGHT_EDIT);
	m_hwndWeightText = GetDlgItem(hWnd, IDC_WEIGHT_TEXT);

	m_hwndInfoV		 = GetDlgItem(hWnd, IDC_INFO_V);
	m_hwndInfo0		 = GetDlgItem(hWnd, IDC_INFO_0);
	m_hwndInfo1		 = GetDlgItem(hWnd, IDC_INFO_1);

	ISpinnerControl*	iS = GetISpinner(m_hwndWeightSpin);
	ICustEdit*			iE = GetICustEdit(m_hwndWeightEdit);

	iS->SetLimits(0, 1);
	iS->SetAutoScale();
	iS->LinkToEdit(m_hwndWeightEdit, EDITTYPE_FLOAT);

	iS->SetValue(0.5f, false);
	iE->SetText(0.5f);

	ReleaseISpinner(iS);
	ReleaseICustEdit(iE);

	BindToVertex(-1, -1, 0.0f);
	ShowVertexInfo(-1);
}

BOOL KvBonesDlgProc::DlgProc(
		TimeValue t, IParamMap *map,
		HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	char buf[200];
	HMENU hMenu, hSubMenu;
	int nSelect;
	POINT pt;
	BoneInfo *bb, *be;
	UINT nCmdID;
	BOOL bAssign;

	switch (msg) {
		case WM_INITDIALOG:
			OnInitDialog(hWnd);
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_ABOUT:
					DoAboutBox(hInstance, hWnd);
					return TRUE;

				case IDC_PICK_BONES: {
						KvSelectCallback cb(t, KvBones::g_pCurr);
						if (KvBones::ip->DoHitByNameDialog(&cb))
						{
							sprintf(buf, "%d bones", KvBones::g_pCurr->m_nBoneCount);
							SetDlgItemText(hWnd, IDC_MSG_BONES, buf);
						}
					}
					break;

				case IDC_RESET_POS:
					KvBones::g_pCurr->UpdateBoneData(t);
					break;

				case IDC_EDIT_BONES:

					UndoBoneEdit::Create(KvBones::g_pCurr);

					if (DialogBox(hInstance, MAKEINTRESOURCE(IDD_BONE_EDIT), hWnd, EditBoneDialogProc) == IDOK) {
						KvBones::g_pCurr->ForceUpdate();
						theHold.Accept(_T("Edit Bones"));
					} else {
						theHold.Cancel();
					}
					theHold.End();

					break;

				case IDC_SHOW_BONE:
					GetCursorPos(&pt);
					hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_SHOW_BONE_MENU));
					hSubMenu = GetSubMenu(hMenu, 0);

					nCmdID = IDC_BONE_0;

					for (bb = KvBones::s_bonelist_begin(), be = KvBones::s_bonelist_end(); bb != be; ++ bb, ++ nCmdID) {
						if (bb->bone) {
							AppendMenu(hSubMenu, MF_STRING, nCmdID, bb->GetName());
						}
					}

					nSelect = KvBones::g_pCurr->m_nSelectBone;
					if (nSelect == -1)
						CheckMenuItem(hSubMenu, IDC_SHOW_NONE, MF_BYCOMMAND | MF_CHECKED);
					else
						CheckMenuItem(hSubMenu, IDC_BONE_0 + nSelect, MF_BYCOMMAND | MF_CHECKED);

					nSelect = TrackPopupMenu(hSubMenu, TPM_RETURNCMD, pt.x, pt.y, 0, GetDlgItem(hWnd, IDC_SHOW_BONE), NULL);
					DestroyMenu(hMenu);

					if (nSelect >= IDC_BONE_0 && nSelect < IDC_BONE_0 + KvBones::g_pCurr->m_nBoneCount) {
						KvBones::g_pCurr->m_nSelectBone = nSelect - IDC_BONE_0;
						KvBones::g_pCurr->ForceRedraw();

						// switch vertex binding
						if (m_nBoundVertex != -1) {
							BoneInfo* bone = KvBones::g_pCurr->m_pBoneList + KvBones::g_pCurr->m_nSelectBone;
							KvLocalModData* mod = KvBones::g_pCurr->m_pModData;
							Vtx& vtx = mod->m_pList[m_nBoundVertex];
							if (vtx.bone0 == bone)
								BindToVertex(m_nBoundVertex, 0, vtx.wght0);
							else if (vtx.bone1 == bone)
								BindToVertex(m_nBoundVertex, 1, vtx.wght1);
							else
								BindToVertex(-1, -1, 0.0f);
						}

					} else if (nSelect == IDC_SHOW_NONE) {
						KvBones::g_pCurr->m_nSelectBone = -1;
						KvBones::g_pCurr->ForceRedraw();

						BindToVertex(-1, -1, 0.0f);
					}

					break;

				case IDC_ASSIGN:

					bAssign = SendDlgItemMessage(hWnd, IDC_ASSIGN, BM_GETCHECK, 0, 0l);
					if (bAssign)
						KvBonesCommandMode::instance.Install(KvBones::ip, KvBones::g_pCurr, KvBonesMouseCallback::instance);
					else
						KvBonesCommandMode::instance.Remove(KvBones::ip);

					break;

				case IDC_COPY_POS:

					KvBones::g_pCurr->OnCopyPos(t);

					break;

				case IDC_PASTE_POS:

					KvBones::g_pCurr->OnPastePos(t);

					break;
			}
			break;

		case CC_SPINNER_CHANGE:
			switch (LOWORD(wParam)) {
				case IDC_WEIGHT_SPIN:
					if (m_nBoundVertex != -1) {

						UndoVertexEdit::Begin(KvBones::g_pCurr, m_nBoundVertex);

						// set new value in the vertex
						KvLocalModData* mod = KvBones::g_pCurr->m_pModData;
						Vtx& vtx = mod->m_pList[m_nBoundVertex];
						SetVertexWeight(vtx, m_nBoundBone);

						UndoVertexEdit::End();

						// update the info
						ShowVertexInfo(m_nBoundVertex);

						// redraw the scene
						KvBones::g_pCurr->ForceRedraw();
					}
					break;
			}
			break;
	}

	return FALSE;
}

void KvBonesDlgProc::SetVertexWeight(Vtx& vtx, int nBone)
{
	float f = GetWeight();
	bool bBalance = SendDlgItemMessage(m_hWnd, IDC_BALANCE, BM_GETCHECK, 0, 0L) != 0;

	if (nBone == 0) {
		vtx.wght0 = f;
		if (bBalance && vtx.bone1 != NULL) 
			vtx.wght1 = 1.0f - f;
	} else {
		vtx.wght1 = f;
		if (bBalance && vtx.bone0 != NULL) 
			vtx.wght0 = 1.0f - f;
	}
}

// ---------------------------------------------------------------------------
//
// class KvSelectCallback
//

KvSelectCallback::KvSelectCallback(TimeValue t, KvBones* pBones) : m_t(t), m_pBones(pBones)
{
}

TCHAR *KvSelectCallback::dialogTitle()
{
	return __T("Select bones");
}

TCHAR *KvSelectCallback::buttonText()
{
	return __T("Select");
}

BOOL KvSelectCallback::useProc()
{
	return TRUE;
}

void KvSelectCallback::proc(INodeTab &nodeTab)
{
	int nCount = nodeTab.Count();
	if (nCount != 0)
	{
		INode** pList = nodeTab.Addr(0);
		m_pBones->SetBoneList(m_t, pList, nCount);
	}
	else
	{
		m_pBones->SetBoneList(m_t, NULL, 0);
	}
}

BOOL KvSelectCallback::useFilter()
{
	return TRUE;
}

int KvSelectCallback::filter(INode *node)
{
	Object* obj = node->GetObjectRef();
	if (obj && obj->SuperClassID()==HELPER_CLASS_ID && obj->ClassID()==Class_ID(BONE_CLASS_ID,0))
		return 1;
	return 0;
}

//--- KvBones -------------------------------------------------------


IObjParam *	KvBones::ip			= NULL;
HWND		KvBones::hWndDlg	= NULL;
KvBones*	KvBones::g_pCurr	= NULL;
IParamMap *	KvBones::pmapParam	= NULL;

KvBones::KvBones() :
		m_nBoneCount(0), m_pBoneList(NULL),
		m_ModDataSeed(0), m_pModData(NULL),
		m_nSelectBone(-1)
{
	pblock = CreateParameterBlock(
				CURRENT_DESCRIPTOR, 
				PBLOCK_LENGTH, 
				CURRENT_VERSION);
	AxAssert(pblock);
	MakeRefByID(FOREVER, 2, pblock);

	m_pModData = NULL;

	m_nFixedRefs = 1;

	for (int i = 0; i < m_nFixedRefs; ++ i)
		m_pFixedRefs[i] = NULL;
}

KvBones::KvBones(KvBonesObject* ob, INode* node) :
		m_nBoneCount(0), m_pBoneList(NULL),
		m_ModDataSeed(0), m_pModData(NULL),
		m_nSelectBone(-1)
{
	MakeRefByID(FOREVER, SIMPWSMMOD_NODEREF, node);

	MakeRefByID(FOREVER, SIMPWSMMOD_OBREF, ob);

	pblock = CreateParameterBlock(
				CURRENT_DESCRIPTOR, 
				PBLOCK_LENGTH, 
				CURRENT_VERSION);
	AxAssert(pblock);
	MakeRefByID(FOREVER, SIMPWSMMOD_PBLOCKREF, pblock);

	m_nFixedRefs = 1;

	for (int i = 0; i < m_nFixedRefs; ++ i)
		m_pFixedRefs[i] = NULL;
}

KvBones::~KvBones()
{
	delete[] m_pBoneList;
	delete m_pModData;
}

Interval KvBones::LocalValidity(TimeValue t)
{
	// if being edited, return NEVER forces a cache to be built 
	// after previous modifier.
	if (TestAFlag(A_MOD_BEING_EDITED))
		return NEVER; 

	//TODO: Return the validity interval of the modifier
	return NEVER;
}

RefTargetHandle KvBones::Clone(RemapDir& remap)
{
	return NULL;
}

void KvBones::ModifyObject(TimeValue t, ModContext &mc, ObjectState * os, INode *node) 
{
	// update the mapping of vertices to bones

	if (m_pModData != NULL) {
		if (m_pModData->m_nSeed != m_ModDataSeed) {
			delete m_pModData;
			m_pModData = NULL;
		}
	}

	Matrix3* m = os->GetTM();

	if (m_pModData == NULL) {
		bool needDel;
		TriObject* tri = GetTriObjectFromObject(os->obj, t, needDel);
		if (tri != NULL) {
			m_pModData = BuildBoneVertexMapping(&tri->mesh);
		}

		if (needDel)
			delete tri;
	}

	if (!os->obj->IsSubClassOf(triObjectClassID))
		return;

	TriObject *triOb = (TriObject *)os->obj;

	// show selected bone (if any)

	Mesh& mesh = triOb->mesh;

#if 0

	// ----- per-vertex color selection

	if (m_nSelectBone == -1) {
		triOb->mesh.setNumVertCol(0);
		triOb->mesh.setNumVCFaces(0);

		NotifyDependents(Interval(t,t), PART_VERTCOLOR, REFMSG_CHANGE);
		NotifyDependents(Interval(t,t), PART_TOPO, REFMSG_CHANGE);

		os->obj->UpdateValidity(VERT_COLOR_CHAN_NUM, FOREVER);
	} else {
		triOb->mesh.setNumVertCol(2);
		triOb->mesh.setNumVCFaces(triOb->mesh.numFaces);

		KvLocalModData* modData = static_cast<KvLocalModData*>(mc.localData);
		AxAssert(modData != NULL);
		AxAssert(modData->m_nSeed == m_ModDataSeed);

		BoneInfo* boneSel = m_pBoneList + m_nSelectBone;

		for (int i = 0; i < triOb->mesh.numFaces; ++ i) {
			for (int j = 0; j < 3; ++ j) {
				int v = triOb->mesh.faces[i].v[j];

				if (v >= 0 && v < modData->m_nCount) {
					Vtx& vtx = modData->m_pList[v];

					if (vtx.bone0 == boneSel || vtx.bone1 == boneSel)
						triOb->mesh.vcFace[i].t[j] = 1;
					else
						triOb->mesh.vcFace[i].t[j] = 0;
				} else {
					triOb->mesh.vcFace[i].t[j] = 0;
				}
			}
		}

		triOb->mesh.vertCol[0] = Point3(0.0f, 0.0f, 1.0f);	// neutral
		triOb->mesh.vertCol[1] = Point3(1.0f, 0.0f, 0.0f);	// affected

		NotifyDependents(Interval(t,t), PART_VERTCOLOR, REFMSG_CHANGE);
		NotifyDependents(Interval(t,t), PART_TOPO, REFMSG_CHANGE);

		os->obj->UpdateValidity(VERT_COLOR_CHAN_NUM, FOREVER);
	}

#else

	// ----- vertex selection highlight

//	theHold.Suspend();

	if (m_nSelectBone == -1) {
		mesh.vertSel.SetSize(0);
		mesh.ClearDispFlag(DISP_VERTTICKS|DISP_SELVERTS);
	} else {
		mesh.vertSel.SetSize(mesh.numVerts);
		mesh.SetDispFlag(DISP_VERTTICKS|DISP_SELVERTS);

		KvLocalModData* modData = m_pModData;

		BoneInfo* boneSel = m_pBoneList + m_nSelectBone;

		for (int i = 0; i < mesh.numVerts; ++ i) {
			Vtx& vtx = modData->m_pList[i];
			if (vtx.bone0 == boneSel || vtx.bone1 == boneSel)
				mesh.vertSel.Set(i);
			else
				mesh.vertSel.Clear(i);
		}
	}

//	theHold.Resume();

#endif

	// call the base class to do deformation

	inherited::ModifyObject(t, mc, os, node);

	// save copy of mesh
	m_meshCopy = mesh;
}

void KvBones::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	this->ip = ip;
	this->g_pCurr = this;

	inherited::BeginEditParams(ip,flags,prev);

	pmapParam = CreateCPParamMap(
		descParam, 0, // PARAMDESC_LENGTH,
		pblock, 
		ip, 
		hInstance, 
		MAKEINTRESOURCE(IDD_PANEL),
		GetString(IDS_PARAMS), 
		0);

	pmapParam->SetUserDlgProc(&KvBonesDlgProc::instance);

//	KvBonesCommandMode::instance.Install(ip, this, KvBonesMouseCallback::instance);

	/*
	hWndDlg = ip->AddRollupPage( 
			hInstance, 
			MAKEINTRESOURCE(IDD_PAGE_KVBONES),
			DialogProc,
			GetString(IDS_PAGE_KVBONES), 
			(LPARAM)ip, APPENDROLL_CLOSED);
	*/
}

void KvBones::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	inherited::EndEditParams(ip,flags,next);

	DestroyCPParamMap(pmapParam);

	/*
	ip->DeleteRollupPage(hWndDlg);
	hWndDlg = NULL;
	*/

	KvBonesCommandMode::instance.Remove(ip);

	this->ip = NULL;
	this->g_pCurr = NULL;
}

void KvBones::SetBoneList(TimeValue t, INode** pList, int nCount)
{
	int i;
	int base = inherited::NumRefs();

	// release old bone references

	for (i = 0; i < m_nBoneCount; ++ i)
		DeleteReference(i + base);

	delete[] m_pBoneList;

	// make new bone references

	m_pBoneList = new BoneInfo[nCount];
	m_nBoneCount = nCount;

	for (i = 0; i < m_nBoneCount; ++ i) {
		MakeRefByID(FOREVER, i + m_nFixedRefs + base, pList[i]);
	}

	// update bone matrices

	UpdateBoneData(t);
}

void KvBones::UpdateBoneData(TimeValue t)
{
	int i;
	BoneInfo* pBone;

	// figure out bone starting and ending points

	for (i = m_nBoneCount, pBone = m_pBoneList; i > 0 ; -- i, ++ pBone) {
		pBone->bone = false;

#ifdef _DEBUG
		const TCHAR* ptcsName = pBone->GetName();
#endif

		pBone->bone	= pBone->GetPQ(t, pBone->p, pBone->q);
		if (pBone->bone) {	
			pBone->qmp		= pBone->q - pBone->p;
			pBone->qmplen	= Length(pBone->qmp);
		}

#ifdef ENABLE_TWIST
		pBone->GetBase(t, pBone->matBase);
#endif
	}

	// make sure we update vertex -> bone mapping next time

	ForceUpdate();
}

KvLocalModData*		KvBones::BuildBoneVertexMapping(Mesh* mesh)
{
	KvLocalModData* data = new KvLocalModData(mesh->numVerts);

	data->m_nSeed = m_ModDataSeed;

	Point3*					mvb = mesh->verts;
	Point3*					mve = mesh->verts + mesh->numVerts;

	BoneInfo*	bb = m_pBoneList;
	BoneInfo*	be = m_pBoneList + m_nBoneCount;

	while (bb != be) {
		if (bb->bone) {
			bb->curve.PrepareForGetValue();
		}
		++ bb;
	}

	Vtx*	vtx = data->m_pList;

	struct BoneSearch {
		BoneInfo*	bone;
		float		dist;
		float		wght;
	};

	while (mvb != mve) {
		// find best two bones for this vertex

		BoneSearch	b0, b1;

		b0.bone = NULL;
		b0.dist = 1e25f;
		b0.wght = 0.0f;

		b1.bone = NULL;
		b1.dist = 1e25f;
		b1.wght = 0.0f;

		bb = m_pBoneList;
		be = m_pBoneList + m_nBoneCount;

		while (bb != be) {
			if (bb->bone) {
				float t = DotProd(bb->qmp, *mvb - bb->p) / (bb->qmplen * bb->qmplen);

				// the projection has to fall within the [p1, q1] of the bone
				float wght;
				if (bb->curve.GetValue(t, wght)) {
					float dist = Length(bb->p + t * bb->qmp - *mvb);

					if (dist < b0.dist) {
						// better than b0
						b1 = b0;
						b0.bone = bb;
						b0.dist = dist;
						b0.wght = wght;
					} else if (dist < b1.dist) {
						// better than b1
						b1.bone = bb;
						b1.dist = dist;
						b1.wght = wght;
					}
				}
			}

			++ bb;
		}

		// set bones and weights

		AxAssert(b1.bone == NULL || b0.bone != NULL);
		AxAssert(b0.bone != NULL || b0.wght == 0.0f);
		AxAssert(b1.bone != NULL || b1.wght == 0.0f);

		// only assign two bones if they are linked in a hierarchy

		if (b0.bone != NULL && b1.bone != NULL) {
			if (!b0.bone->IsParentOf(b1.bone) && !b1.bone->IsParentOf(b0.bone)) {
				b1.bone = NULL;
				b1.wght = 0.0f;
			}
		}

		vtx->bone0 = b0.bone;
		vtx->wght0 = b0.wght / (b0.wght + b1.wght);

		vtx->bone1 = b1.bone;
		vtx->wght1 = b1.wght / (b0.wght + b1.wght);

		// advance

		++ mvb;
		++ vtx;
	}

	return data;
}

void KvBones::ForceUpdate()
{
	++ m_ModDataSeed;
	NotifyDependents(FOREVER, ChannelsChanged(), REFMSG_CHANGE);
}

void KvBones::ForceRedraw()
{
	NotifyDependents(FOREVER, ChannelsChanged(), REFMSG_CHANGE);
}

void KvBones::OnCopyPos(TimeValue t)
{
	m_PosBuffer.CopyPos(t, m_pBoneList, m_nBoneCount);
}

void KvBones::OnPastePos(TimeValue t)
{
	if (m_PosBuffer.PastePos(t, m_pBoneList, m_nBoneCount))
	{
		ForceRedraw();
	}
}

BoneInfo*	KvBones::s_bonelist_begin()
{
	AxAssert(g_pCurr != NULL);
	return g_pCurr->m_pBoneList;
}

BoneInfo*	KvBones::s_bonelist_end()
{
	AxAssert(g_pCurr != NULL);
	return g_pCurr->m_pBoneList + g_pCurr->m_nBoneCount;
}

//From SimpleMod 

Interval KvBones::GetValidity(TimeValue t)
{
	Interval valid = FOREVER;

	// intersect with dummy parameter
	float f;	
	pblock->GetValue(PB_VAL_VALUE,t,f,valid);

	// intersect with validuty of transformations for all bones

	for (int i = 0; i < m_nBoneCount; ++ i) {
		if (m_pBoneList[i].bone)
			m_pBoneList[i].pNode->GetNodeTM(t, &valid);
	}

	return valid;
}

int KvBones::NumRefs()
{
	int base = inherited::NumRefs();
	return base + m_nFixedRefs + m_nBoneCount;
}

RefTargetHandle KvBones::GetReference(int i)
{
	int base = inherited::NumRefs();

	if (i < base)
		return inherited::GetReference(i);

	if (i < base + m_nFixedRefs)
		return m_pFixedRefs[i - base];

	if (i < base + m_nFixedRefs + m_nBoneCount)
		return m_pBoneList[i - m_nFixedRefs - base].pNode;

	AxAssert(0);
	return NULL;
}

void KvBones::SetReference(int i, RefTargetHandle rtarg)
{
	int base = inherited::NumRefs();

	if (i < base) {
		inherited::SetReference(i, rtarg);
		return;
	}

	if (i < base + m_nFixedRefs)
	{
		m_pFixedRefs[i - base] = rtarg;
		return;
	}

	if (i < base + m_nFixedRefs + m_nBoneCount)
	{
		m_pBoneList[i - m_nFixedRefs - base].pNode = (INode*) rtarg;
		return;
	}

	AxAssert(0);
}

Deformer& KvBones::GetDeformer(
		TimeValue t,ModContext &mc,Matrix3& mat,Matrix3& invmat)
{
	static KvBonesDeformer deformer;

	KvLocalModData* modData = m_pModData;

	Interval valid = FOREVER;

	float f;
	pblock->GetValue(PB_VAL_VALUE, t, f, valid);

	deformer.Init(t, this, f, modData);

	return deformer;
}

ParamDimension *KvBones::GetParameterDim(int pbIndex) 
{
	//TODO: Return the various parameter dimensions based on pbIndex
	return defaultDim;
}

TSTR KvBones::GetParameterName(int pbIndex) 
{
	//TODO: Return the various parameter names based on pbIndex
	return GetString(IDS_PARAMS);
}

//From ReferenceMaker 
RefResult KvBones::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 
{
	int i;

	switch (message) {
		case REFMSG_CHANGE:
			for (i = m_nBoneCount - 1; i >= 0; i --) {
				if (m_pBoneList[i].pNode == hTarget)
				{
				}
			}
			break;

		case REFMSG_TARGET_DELETED:

			if (nodeRef == hTarget) {
				nodeRef = NULL;
			} else if (obRef == hTarget) {
				obRef = NULL;
			} else if (pblock == hTarget) {
				pblock = NULL;
			} else for (i = m_nBoneCount - 1; i >= 0; i --)	{
				if (m_pBoneList[i].pNode == hTarget) {
					// DeleteReference(i + 1);

					m_pBoneList[i] = m_pBoneList[m_nBoneCount - 1];
					m_nBoneCount --;

					NotifyDependents(FOREVER, ChannelsChanged(), REFMSG_CHANGE);

					break;
				}
			}

			break;
	}

	return REF_SUCCEED;
}


//From Object
BOOL KvBones::HasUVW() 
{ 
	//TODO: Return whether the object has UVW coordinates or not
	return TRUE; 
}

void KvBones::SetGenUVW(BOOL sw) 
{  
	if (sw==HasUVW()) return;
	//TODO: Set the plugin internal value to sw				
}

//TODO: This is the callback object used by ILoad::RegisterPostLoadCallback()
class KvBonesPostLoadCallback : public PostLoadCallback {
	public:
		ParamBlockPLCB *cb; 
		KvBonesPostLoadCallback(ParamBlockPLCB *c) {cb = c;}
		//TODO: This method is called when everything has been loaded
		void proc(ILoad *iload) {};
};

IOResult KvBones::Save(ISave *isave)
{
	inherited::Save(isave);

	isave->BeginChunk(BONES_DATA_CHUNK);

	// bone count
	ULONG nwrit;
	isave->Write(&m_nBoneCount, sizeof(m_nBoneCount), &nwrit);

	// bones
	for (int i = 0; i < m_nBoneCount; ++ i)
		m_pBoneList[i].Save(isave);

	// vertex mapping
	m_pModData->Save(isave, m_pBoneList, m_nBoneCount);

	isave->EndChunk();
	
	return IO_OK;
}

IOResult KvBones::Load(ILoad *iload)
{
	inherited::Load(iload);

	IOResult res;
	ULONG nread;

	while (IO_OK==(res=iload->OpenChunk())) {
		switch (iload->CurChunkID()) {
			case BONES_DATA_CHUNK:

				// bone count
				iload->Read(&m_nBoneCount, sizeof(m_nBoneCount), &nread);

				// bones
				m_pBoneList = new BoneInfo[m_nBoneCount];
				for (int i = 0; i < m_nBoneCount; ++ i)
					m_pBoneList[i].Load(iload);

				// vertex mapping
				m_pModData = new KvLocalModData(iload, m_pBoneList, m_nBoneCount);

				break;
		}

		iload->CloseChunk();
	}

	return IO_OK;
}

